# Class VoidInputFilter

java.lang.Object
org.apache.coyote.http11.filters.VoidInputFilter

All Implemented Interfaces:
  `InputFilter`, `InputBuffer`

public class VoidInputFilter extends Object implements InputFilter
Void input filter, which returns -1 when attempting a read. Used with a GET, HEAD, or a similar request.

Author:
  Remy Maucherat

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `protected static final ByteChunk`
  `ENCODING`
  `protected static final String`
  `ENCODING_NAME`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `VoidInputFilter()`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `int`
  `available()`
  Obtain an estimate of the number of bytes that can be read without blocking.
  `int`
  `doRead(ApplicationBufferHandler handler)`
  Read from the input stream into the ByteBuffer provided by the ApplicationBufferHandler.
  `long`
  `end()`
  End the current request.
  `ByteChunk`
  `getEncodingName()`
  Get the name of the encoding handled by this filter.
  `boolean`
  `isFinished()`
  Has the request body been read fully?
  `void`
  `recycle()`
  Make the filter ready to process the next request.
  `void`
  `setBuffer(InputBuffer buffer)`
  Set the next buffer in the filter pipeline.
  `void`
  `setRequest(Request request)`
  Some filters need additional parameters from the request.

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Field Details

  - ### ENCODING_NAME

    protected static final String ENCODING_NAME
    See Also:
      - Constant Field Values

  - ### ENCODING

    protected static final ByteChunk ENCODING

- ## Constructor Details

  - ### VoidInputFilter

    public VoidInputFilter()

- ## Method Details

  - ### doRead

    public int doRead(ApplicationBufferHandler handler) throws IOException
    Description copied from interface: `InputBuffer`
    Read from the input stream into the ByteBuffer provided by the ApplicationBufferHandler. IMPORTANT: the current model assumes that the protocol will 'own' the ByteBuffer and return a pointer to it.
    Specified by:
      `doRead` in interface `InputBuffer`
    Parameters:
      `handler` - ApplicationBufferHandler that provides the buffer to read data into.
    Returns:
      The number of bytes that have been added to the buffer or -1 for end of stream
    Throws:
      `IOException` - If an I/O error occurs reading from the input stream

  - ### setRequest

    public void setRequest(Request request)
    Description copied from interface: `InputFilter`
    Some filters need additional parameters from the request.
    Specified by:
      `setRequest` in interface `InputFilter`
    Parameters:
      `request` - The request to be associated with this filter

  - ### setBuffer

    public void setBuffer(InputBuffer buffer)
    Description copied from interface: `InputFilter`
    Set the next buffer in the filter pipeline.
    Specified by:
      `setBuffer` in interface `InputFilter`
    Parameters:
      `buffer` - The next buffer

  - ### recycle

    public void recycle()
    Description copied from interface: `InputFilter`
    Make the filter ready to process the next request.
    Specified by:
      `recycle` in interface `InputFilter`

  - ### getEncodingName

    public ByteChunk getEncodingName()
    Description copied from interface: `InputFilter`
    Get the name of the encoding handled by this filter.
    Specified by:
      `getEncodingName` in interface `InputFilter`
    Returns:
      The encoding name as a byte chunk to facilitate comparison with the value read from the HTTP headers which will also be a ByteChunk

  - ### end

    public long end() throws IOException
    Description copied from interface: `InputFilter`
    End the current request.
    Specified by:
      `end` in interface `InputFilter`
    Returns:
      0 is the expected return value. A positive value indicates that too many bytes were read. This method is allowed to use buffer.doRead to consume extra bytes. The result of this method can't be negative (if an error happens, an IOException should be thrown instead).
    Throws:
      `IOException` - If an error happens

  - ### available

    public int available()
    Description copied from interface: `InputBuffer`
    Obtain an estimate of the number of bytes that can be read without blocking. Typically, this will be the number of available bytes known to be buffered.
    Specified by:
      `available` in interface `InputBuffer`
    Returns:
      The number of bytes that can be read without blocking

  - ### isFinished

    public boolean isFinished()
    Description copied from interface: `InputFilter`
    Has the request body been read fully?
    Specified by:
      `isFinished` in interface `InputFilter`
    Returns:
      `true` if the request body has been fully read, otherwise `false`